      SUBROUTINE  RCAWBUF(ISYSTM,A1,A2,A3,A4,A5)
C
C        RCAWBUF/RCAWRIT IS USED TO WRITE RCA DUMPS TO DISK
C                        IT REDUCES DISK I/O BY PROVIDING AN INTERNAL
C                        BUFFER TO HOLD INTERMEDIATE VALUES
      SAVE
      INCLUDE  'RCACM'

      REAL  BUF1(1000),BUF2(3000),BUF3(5000),BUF4(7000),BUF5(9000),
     .   BUF6(11000),BUF7(15000),BUF8(20000),BUF9(30000),BUFFER(50000)

      EQUIVALENCE 
     .   (BUFFER(1),BUF1(1)) , (BUFFER(1),BUF2(1)) , (BUFFER(1),BUF3(1))
     . , (BUFFER(1),BUF4(1)) , (BUFFER(1),BUF5(1)) , (BUFFER(1),BUF6(1))
     . , (BUFFER(1),BUF7(1)) , (BUFFER(1),BUF8(1)) , (BUFFER(1),BUF9(1))
C
      DATA  INITBUF/0/,ICNT/0/
      IF(INITBUF.EQ.0) THEN
       BUFFER=0.0
       INITBUF=1
      ENDIF

      BUFFER(ICNT+1) = A1
      BUFFER(ICNT+2) = A2
      BUFFER(ICNT+3) = A3
      BUFFER(ICNT+4) = A4
      BUFFER(ICNT+5) = A5
      ICNT = ICNT + 5
      IF(ICNT.GT.50000)  THEN
         WRITE(OUT,1200)   ICNT
 1200    FORMAT(//10X,'RCADWRIT ERROR...'/
     .       10X,'MAXIMUM BUFFER SIZE OF 50,000 EXCEEDED'/
     .       10X,'(PRODUCT OF NDMPS*NOSYS*5 CANNOT EXCEED 50,000)'/
     .       10X,'RCA PROGRAM TERMINATED'//)
       CALL EXIT
      ENDIF
      RETURN

      ENTRY RCAWRIT

C        BUFFER IS COMPLETE - DUMP TO DISK

      IF(IDDOPT.EQ.0) THEN
        WRITE(12)   TIME
      ELSE
        IF(INITB.EQ.0)  WRITE(12)   TIME
        IF(INITB.GE.1)  WRITE(12)   TIME-(FLOAT(IPRNTDSECS)/86400.)/2.
      ENDIF
      IF(ICNT.LE.1000)   WRITE(13) BUF1
      IF(ICNT.GT.1000 .AND. ICNT.LE.3000)   WRITE(13) BUF2
      IF(ICNT.GT.3000 .AND. ICNT.LE.5000)   WRITE(13) BUF3
      IF(ICNT.GT.5000 .AND. ICNT.LE.7000)   WRITE(13) BUF4
      IF(ICNT.GT.7000 .AND. ICNT.LE.9000)   WRITE(13) BUF5
      IF(ICNT.GT.9000 .AND. ICNT.LE.11000)   WRITE(13) BUF6
      IF(ICNT.GT.11000 .AND. ICNT.LE.15000)   WRITE(13) BUF7
      IF(ICNT.GT.15000 .AND. ICNT.LE.20000)   WRITE(13) BUF8
      IF(ICNT.GT.20000 .AND. ICNT.LE.30000)   WRITE(13) BUF9
      IF(ICNT.GT.30000)   WRITE(13) BUFFER
      CALL FLUSH(12)
      CALL FLUSH(13)

C        RESET ICNT
      RECSIZ = ICNT
      ICNT = 0
      RETURN
      END
